# pdf invoice reader
[![codecov](https://codecov.io/gh/Sigurd-og-Brage-sitt-bachelorprosjekt/pdf-invoice-reader/branch/master/graph/badge.svg?token=D7IPI9RQY6)](https://codecov.io/gh/Sigurd-og-Brage-sitt-bachelorprosjekt/pdf-invoice-reader)
[![CodeScene Code Health](https://codescene.io/projects/12192/status-badges/code-health)](https://codescene.io/projects/12192)
[![CodeScene System Mastery](https://codescene.io/projects/12192/status-badges/system-mastery)](https://codescene.io/projects/12192)
![Pipeline](https://github.com/Sigurd-og-Brage-sitt-bachelorprosjekt/pdf-invoice-reader/workflows/Python%20tests/badge.svg)

A machine learning approach for parsing invoices

## Setup
```
cd C:\dev
git clone https://github.com/Sigurd-og-Brage-sitt-bachelorprosjekt/pdf-invoice-reader
cd pdf-invoice-reader\

# osx
python3 -m pip install --user virtualenv
python3 -m venv env
source env/bin/activate 

# windows
python -m pip install --user virtualenv
python -m venv env
.\env\Scripts\activate

pip3 install -r requirements.txt
```

[See here for a guide on virtual vnvironments](https://packaging.python.org/guides/installing-using-pip-and-virtual-environments/)

## DVC
This projects is using `dvc` for tracking the state of the models and dataset with the git commits.

Run
```
dvc pull
```

Then the dataset will be downloaded to the root directory. 

## Running tests, linters, type checker and coverage
```
pytest
pylint pdfinvoicereader
mypy .
coverage run --source=pdfinvoicereader -m pytest
coverage report
```
Or to run them all at the same time
```
coverage run --source=pdfinvoicereader -m pytest && pylint pdfinvoicereader && mypy . && coverage report
```

## For PyCharm:
Open project in pycharm

Go to Settings -> Tools -> Python Integrated Tools -> Default test runner=PyTest  
If there is a "no pytest found" warning at the bottom, press "Fix"  
Exit settings  
Press edit configurations in the top bar-> Press + -> Python Tests -> PyTest -> OK -> Run the configuration by pressing the button in "run" button.  
Press "run with coverage" to see coverage

Install the plugins "mypy" and "pylint" and restart PyCharm. There are two new tabs at the bottom. open them and press "check project" to run mypy and pylint on the whole project.