from .dataset.dataset_loader import DatasetLoader
from .resolver.kid import Kid
from .resolver.text_resolver import TextResolver


class Accuracy:
    def __init__(self) -> None:
        pass

    def get_accuracy(self, resolver: TextResolver, dataset: DatasetLoader, field: str) -> float:
        correct = 0
        total = 0
        for entry in dataset:

            text = entry.text
            correct_field_value = entry.json[field]
            if not Kid(correct_field_value).is_valid():
                raise ValueError(f"KID {correct_field_value} in dataset entry {entry} is invalid")
            if correct_field_value is None:
                continue
            correct += int(correct_field_value in resolver.find_in_text(text))
            total += 1
        return correct / total
