from flask import Flask
from flask_cors import CORS
from graphene_file_upload.flask import FileUploadGraphQLView
from pdfinvoicereader.api.schema import schema


def create_app():
    app = Flask(__name__)
    CORS(app)
    app.add_url_rule(
        "/graphql",
        view_func=FileUploadGraphQLView.as_view(
            "graphql",
            schema=schema,
            graphiql=True,
        ),
    )
    return app
