import graphene

from .field import DateField, StringField


class Invoice(graphene.ObjectType):
    kid = graphene.Field(StringField)
    date = graphene.Field(DateField)
    due_date = graphene.Field(DateField)
    principal_amount = graphene.Field(StringField)
    customer_number = graphene.Field(StringField)
    invoice_account_number = graphene.Field(StringField)
    invoice_number = graphene.Field(StringField)

    def resolve_kid(self, info: graphene.ResolveInfo) -> graphene.Field:  # # pylint: disable=W0613
        return self.kid

    def resolve_date(self, info: graphene.ResolveInfo) -> graphene.Field:  # # pylint: disable=W0613
        return self.date

    def resolve_due_date(self, info: graphene.ResolveInfo) -> graphene.Field:  # # pylint: disable=W0613
        return self.due_date

    def resolve_principal_amount(self, info: graphene.ResolveInfo) -> graphene.Field:  # # pylint: disable=W0613
        return self.principal_amount

    def resolve_customer_number(self, info: graphene.ResolveInfo) -> graphene.Field:  # # pylint: disable=W0613
        return self.customer_number

    def resolve_invoice_account_number(self, info: graphene.ResolveInfo) -> graphene.Field:  # # pylint: disable=W0613
        return self.invoice_account_number

    def resolve_invoice_number(self, info: graphene.ResolveInfo) -> graphene.Field:  # # pylint: disable=W0613
        return self.invoice_number
