import re

from ..validators.validator import Validator


class NumberField(Validator[str]):  # pylint: disable=E1136  # pylint/issues/2822
    def __init__(self, text: str) -> None:
        self.text = text

    @staticmethod
    def validate(input_str: str) -> bool:
        if not re.match(r"^[0-9]+$", input_str):
            return False
        return True

    def is_valid(self) -> bool:
        return self.validate(self.text)
