import os

from .utils.parse_config import parse_data_config

# data_config = "bankvoucher.data" if "bankvoucher" in sys.argv else "custom.data"

current_dir = os.path.dirname(os.path.abspath(__file__))
model_def = os.path.join(current_dir, "config/yolov3-tiny.cfg")
data_config = os.path.join(current_dir, "config/custom.data")
checkpoint_path = os.path.join(current_dir, "checkpoints/latest_checkpoint.pth")


def get_data_config(is_bank_voucher):
    if is_bank_voucher:
        name = "custom_bankvoucher.data"
    else:
        name = "custom.data"
    return os.path.join(current_dir, "config", name)


def get_model_prefix(is_bank_voucher):
    if is_bank_voucher:
        return "bankvoucher_model_v2"
    else:
        return "invoice_model_v2"


def root_image_dir():
    global data_config, current_dir
    local_data_config = parse_data_config(data_config)
    root_path = os.path.join(current_dir, local_data_config["root_folder"])
    json_path = os.path.join(current_dir, local_data_config["json_folder"])
    image_path = os.path.join(root_path, "images")
    return data_config, image_path, json_path
