import os
from collections import defaultdict


class WeightedDataloder:
    def __init__(self, group_creditor_invoices, files):
        self.group_creditor_invoices = group_creditor_invoices
        self.inverse_group_creditor_invoices = {
            str(v): i for i in self.group_creditor_invoices for v in self.group_creditor_invoices.get(i, [])
        }
        self.files = files
        self.creditor_id_resolver = lambda x: os.path.basename(x).split("_")[0]

    def create_split(self):
        clustered_files = defaultdict(list)
        for i in self.files:
            creditor_id = self.creditor_id_resolver(i)
            class_id_found = self.inverse_group_creditor_invoices.get(str(creditor_id), None)
            if class_id_found is not None:
                clustered_files[class_id_found].append(i)
        return clustered_files

    def get_new_batch(self):
        clustered_files = self.create_split().values()
        min_size = len(min(clustered_files, key=lambda x: len(x)))

        clustered_files = [i[:min_size] for i in clustered_files]
        return sum(clustered_files, [])
